



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>asp.net MVC中如何用Membership类和自定义的数据库进行登录验证</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">asp.net MVC中如何用Membership类和自定义的数据库进行登录验证</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 07:32:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>asp.net MVC&nbsp;内置的membershipProvider可以实现用户登陆验证，但是它用的是自动创建的数据库，所以你想用本地数据库数据去验证，是通过不了的。</p>
<p>如果我们想用自己的数据库的话，可以写自己的membershipProvider！下面介绍如果创建自己的membershipProvider：</p>
<p><strong>1.写自己的MembershipProvider类，这个类继承自命名空间System.Web.Security下的MembershipProvider类</strong></p>
<p>这个类放在哪无所谓，这里我放在新建MyCode文件夹里，然后新建类，取名为MyMembershipProvider，代码如下：</p>
<div>
<pre class="prettyprint linenums">using System.Web.Security;namespace MvcWeb.MyCode<br />
{<br />
    //自定义类，继承System.Web.Security.MembershipProvider<br />
    public class MyMembershipProvider: MembershipProvider<br />
    {<br />
    }<br />
}</pre>
</div>
<p>现在加代码进去，把鼠标光标放在MembershipProvider上，右键选择&ldquo;实现抽象类&rdquo;</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/627627/201409/271350425148764.jpg" /></p>
<p>实现抽象类后会有很多方法，这里只用到最后一个方法代码如下：</p>
<div>
<pre class="prettyprint linenums">using System.Data.SqlClient;<br />
namespace MvcFeiGeTe.MyCode<br />
{<br />
    //自定义类，继承System.Web.Security.MembershipProvider<br />
    public class MyMembershipProvider: MembershipProvider<br />
    {<br />
        public override bool ValidateUser(string username, string password)<br />
        {<br />
            throw new NotImplementedException();<br />
        }<br />
    }<br />
}</pre>
</div>
<p>下面是填充上面方法的代码：</p>
<div>
<pre class="prettyprint linenums"> public override bool ValidateUser(string username, string password)<br />
        {<br />
            SqlConnection sqlconn = new SqlConnection("Data Source=.;Initial Catalog=MyDb;Integrated Security=True;user id=sa;password=admin123");<br />
            SqlCommand sqlcmd = new SqlCommand("select userName,passWord from adminInfo where userName = @userName and passWord = @passWord", sqlconn);<br />
            try<br />
            {<br />
                sqlconn.Open();<br />
                sqlcmd.Parameters.Add(new SqlParameter("@userName", SqlDbType.NVarChar, ));<br />
                sqlcmd.Parameters["@userName"].Value = username.Trim();<br />
                sqlcmd.Parameters.Add(new SqlParameter("@passWord", SqlDbType.NVarChar, ));<br />
                sqlcmd.Parameters["@passWord"].Value = password.Trim();<br />
                SqlDataReader sqlRd = sqlcmd.ExecuteReader();<br />
                if (sqlRd.HasRows)<br />
                {<br />
                    return true;<br />
                }<br />
                return false;<br />
            }<br />
            catch (Exception ex)<br />
            {<br />
                throw new Exception(ex.Message);<br />
            }<br />
        }</pre>
</div>
<p><strong>2.配置Web.config</strong></p>
<p>把此配置文件下的&lt;system.web&gt;节点下的默认的&lt;membership&gt;节点换成如下（注意下划线部分）：</p>
<div>
<pre class="prettyprint linenums"> &lt;membership defaultProvider="MyMembershipProvider"&gt;<br />
      &lt;providers&gt;<br />
        &lt;add name="MyMembershipProvider" type="MvcWeb.MyCode.MyMembershipProvider, System.Web.Providers, Version=1.0.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35" connectionStringName="DefaultConnection" enablePasswordRetrieval="false" enablePasswordReset="true" requiresQuestionAndAnswer="false" requiresUniqueEmail="false" maxInvalidPasswordAttempts="" minRequiredPasswordLength="" minRequiredNonalphanumericCharacters="" passwordAttemptWindow="" applicationName="/" /&gt;<br />
      &lt;/providers&gt;<br />
    &lt;/membership&gt;</pre>
</div>
<p><strong>3.验证</strong></p>
<p>在AccountController中：</p>
<div>
<pre class="prettyprint linenums">if (ModelState.IsValid)<br />
            {<br />
                string password = FormsAuthentication.HashPasswordForStoringInConfigFile(model.passWord, "md5");  //加密<br />
                MyMembershipProvider mmsp = new MyMembershipProvider();   //自定义MyMembershipProvider，继承mvc自带的MembershipProvider,实现登陆验证，添加引用using MvcWeb.MyCode;<br />
                if (mmsp.ValidateUser(model.userName, password))<br />
                {<br />
                    FormsAuthentication.SetAuthCookie(model.userName, true);<br />
                    if (Url.IsLocalUrl(returnUrl) &amp;&amp; returnUrl.Length &gt;  &amp;&amp; returnUrl.StartsWith("/")<br />
                        &amp;&amp; !returnUrl.StartsWith("//") &amp;&amp; !returnUrl.StartsWith("/\\"))<br />
                    {<br />
                        return Redirect(returnUrl);<br />
                    }<br />
                    else<br />
                    {<br />
                        return RedirectToAction("Index", "Admin");<br />
                    }<br />
                }<br />
                else<br />
                {<br />
                    ModelState.AddModelError("", "用户名或密码输入有误");<br />
                }<br />
            }</pre>
</div>
<p>ok!</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq471jqz.html">细说SSO单点登录</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4pwlnq.html">Linux Core Dump</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ej4lj9.html">Blender2&period;5快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdrlxj8.html">a标签中调用js方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq161nz8.html">一些关于HTTP协议、表单和&hellip;&hellip;的备忘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydgy4xq.html">【转】正确理解PHP程序编译时的错误信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjl7wd9.html">Java系列--第二篇 基于Maven的Android开发HelloAndroidWorld</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mj3738.html">LinkedHashMap遍历</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy15pgmq.html">java 字符串全排列 和 去重</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo6g1nq.html">tensorflow笔记（四）之MNIST手写识别系列一</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdyk049.html">hihoCoder 1288   Font Size 二分</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdokjd9.html">【Matlab编程】生日快乐歌&lpar;显示歌词&rpar;&mdash;matlab版</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jpnnl8.html">Y1吐槽001 怎么做产品</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rwdg48.html">Maven学习 二 Maven环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyewr19.html">CVE-2015-1641 Office类型混淆漏洞及shellcode分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvxdzk8.html">扫盲记-第六篇--Normalization</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2515noq.html">在Ubuntu 14&period;04&period;1中安装VMware Tools的步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kxr5xq.html">express 默认模板引擎</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkloon8.html">BZOJ5298 CQOI2018交错序列（动态规划&plus;矩阵快速幂）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvd17zyq.html">20169214 2016-2017-2 《网络攻防实践》第十一周实验 SQL注入</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9pz1zy8.html">css 框架&mdash;&mdash;base&period;css，作用是重设浏览器默认样式和提供通用原子类。自己留存</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1gz35q.html">PDO常用方法及其应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvgv4yq.html">在openGL中绘制图形</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvgv6yq.html">hdu-acm steps Common Subsequence</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p1dgz9.html">IP地址在数据库里面的存储方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd6px08.html">Layui - 示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/m9660kj9.html">【新产品发布】【GK101 10MHz任意波发生器】</a>
			</li>
						<li><a href="https://www.batexi.com/a/r930jww9.html">&lbrack;服务器&rsqb;脚本：批处理带参数ping命令 发送邮件脚本</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7p7eeq.html">&lbrack;ZZ&rsqb; HDR&amp;amp&semi;ToneMapping</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1g5n0q.html">Redis 笔记与总结7 PHP &plus; Redis 信息管理系统（用户信息的增删改查）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
